"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _TextControllerView = _interopRequireDefault(require("./TextControllerView"));

var _HighlightItem = _interopRequireDefault(require("./HighlightItem"));

var _ReplaceAt = _interopRequireDefault(require("../Utilities/ReplaceAt"));

var _UpdateHighlights = _interopRequireDefault(require("../Utilities/UpdateHighlights"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

var TextController =
/*#__PURE__*/
function (_Component) {
  _inherits(TextController, _Component);

  function TextController(props) {
    var _this;

    _classCallCheck(this, TextController);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(TextController).call(this, props));
    _this.props = props;
    _this.highlightDict = {};
    _this.phrases = props.phrases;
    _this.highlightedTextArr = [];
    _this.state = {
      textInput: props.defaultText,
      result: ""
    };
    _this.handleTextAreaChange = _this.handleTextAreaChange.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.handleInputSubmit = _this.handleInputSubmit.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.highlightPhrases = _this.highlightPhrases.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.handleMouseOver = _this.handleMouseOver.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.handleMouseExit = _this.handleMouseExit.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    return _this;
  } //resets the control getting it ready for new input


  _createClass(TextController, [{
    key: "reset",
    value: function reset() {
      this.highlightDict = {};
      this.highlightedTextArr = [];
      this.setState({
        result: ""
      });
    } //Calculate Highlights - reset control and parse Phrases

  }, {
    key: "calcHighlights",
    value: function calcHighlights() {
      var _this2 = this;

      var strInput = this.state.textInput.toLowerCase();
      this.reset();
      Object.keys(this.phrases).forEach(function (phraseSet) {
        _this2.parsePhrases(_this2.phrases[phraseSet], phraseSet, strInput);
      });
      this.highlightPhrases(this.highlightDict);
    } //parse the phrases in each phraseSet and create a HighlightDictionary w/ HighlightItems

  }, {
    key: "parsePhrases",
    value: function parsePhrases(phrases, phraseColor, strInput) {
      var _this3 = this;

      var _loop = function _loop(i) {
        //loop through each of our phrases
        var startIdx = 0;
        var string = strInput.replace(/[.,\/#!$%\^&\*;:{}=\-_`~()]/g, "").replace(/\s\s+/g, ' ');
        console.log(string);
        var phraseIdx = string.indexOf(phrases[i], startIdx);
        console.log(phrases[i]);

        var _loop2 = function _loop2() {
          console.log(phrases[i], startIdx);
          words = phrases[i].split(" "); //split phrase up into words

          var offset = 0;
          words.forEach(function (word) {
            //for each word get its index and check if its in HighlightDict
            var wordIdx = strInput.indexOf(word, phraseIdx + offset);
            offset = word.length;
            var phrasesArry = [];
            var idx = phraseIdx + "-" + phrases[i].length;
            var phraseObj = {};
            phraseObj[idx] = phrases[i];
            phrasesArry.push(phraseObj); //if not in HighlictDict create a new item, otherwise update it

            if (!(wordIdx in _this3.highlightDict)) _this3.highlightDict[wordIdx] = new _HighlightItem.default(word, phrasesArry, phraseColor, 'textBlack', wordIdx);else _this3.highlightDict[wordIdx].update(phraseColor, phraseObj);
          });
          startIdx = phraseIdx + phrases[i].length;
          phraseIdx = strInput.indexOf(phrases[i], startIdx);
        };

        while (phraseIdx != -1) {
          _loop2();
        }
      };

      for (var i = 0; i < phrases.length; i++) {
        var words;

        _loop(i);
      }
    } //highlight phrases according to the provided highlightDictionary

  }, {
    key: "highlightPhrases",
    value: function highlightPhrases(highlightDict) {
      this.highlightedTextArr = this.state.textInput.split(" ");

      for (var k in highlightDict) {
        //console.log(k);
        this.highlightedTextArr = (0, _ReplaceAt.default)(parseInt(k), highlightDict[k].content, highlightDict[k].color, highlightDict[k].textColor, this.highlightedTextArr, this.props.noWhiteSpace);
      } //check if our array contains an object, if so pull out the JSX element, otherwise add a space


      for (var i = 0; i < this.highlightedTextArr.length; i++) {
        if (_typeof(this.highlightedTextArr[i]) == 'object') this.highlightedTextArr[i] = this.highlightedTextArr[i].element;else //add a space between plain string elements
          this.highlightedTextArr[i] = _react.default.createElement("span", {
            key: i + this.highlightedTextArr[i]
          }, " ", this.highlightedTextArr[i], " ");
      }

      this.setState({
        result: this.highlightedTextArr
      });
    } //* Event Handlers *//

  }, {
    key: "handleTextAreaChange",
    value: function handleTextAreaChange(event) {
      this.setState({
        textInput: event.target.value
      });
    }
  }, {
    key: "handleInputSubmit",
    value: function handleInputSubmit() {
      this.calcHighlights();
    }
  }, {
    key: "handleMouseOver",
    value: function handleMouseOver(event) {
      if (!event.target.getAttribute("class")) {
        return;
      }

      ; //get info from element our mouse entered

      var idx = event.target.getAttribute("data-myid");
      var Targetcolor = event.target.getAttribute("class").split(" ")[0];

      if (!this.highlightDict[idx]) {
        return;
      } //if element idx doesn't exist in highlightDict return


      var PhrasesArr = this.highlightDict[idx].phraseArr;
      var phraseArrEntry = PhrasesArr[PhrasesArr.length - 1]; //get the highest priority phrase entry from the PhraseArray

      var tempcopy = Object.assign({}, this.highlightDict); //make a copy of our highlightDict so we don't modify the original

      var temp = (0, _UpdateHighlights.default)(phraseArrEntry, tempcopy, Targetcolor);
      this.highlightPhrases(temp);
    }
  }, {
    key: "handleMouseExit",
    value: function handleMouseExit() {
      this.highlightPhrases(this.highlightDict);
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.autoStart) this.handleInputSubmit();
    }
  }, {
    key: "render",
    value: function render() {
      return _react.default.createElement(_TextControllerView.default, {
        onSubmit: this.handleInputSubmit,
        handleTextAreaChange: this.handleTextAreaChange,
        textInput: this.state.textInput,
        result: this.state.result,
        onMouseOver: this.handleMouseOver,
        onMouseOut: this.handleMouseExit,
        inputField: this.props.inputField,
        autoStart: this.props.autoStart,
        textAreaCols: this.props.textAreaCols,
        textAreaRows: this.props.textAreaRows
      });
    }
  }]);

  return TextController;
}(_react.Component);

var _default = TextController;
exports.default = _default;