"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _ContainsObject = _interopRequireDefault(require("../Utilities/ContainsObject"));

var _HighlightItem = _interopRequireDefault(require("../Components/HighlightItem"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function updateHighlights(phraseArrEntry, temp, Targetcolor) {
  //loop through our highlightDict checking if our currentElement contains our phraseArrEntry
  for (var k in temp) {
    var currentElement = temp[k];

    if ((0, _ContainsObject.default)(phraseArrEntry, currentElement.phraseArr)) {
      //currentElement contains our phraseArrEntry
      for (var i = 0; i < currentElement.phraseArr.length; i++) {
        //loop through currentElement phraseArray
        //current element has a phrase that isn't the phraseArrEntry
        if (Object.keys(currentElement.phraseArr[i])[0] != Object.keys(phraseArrEntry)[0]) checkForUnnormal(currentElement, i, phraseArrEntry, Targetcolor, temp);
      }
    }
  }

  return temp;
}

function checkForUnnormal(currentElement, i, phraseArrEntry, Targetcolor, temp) {
  //loop through our highlightDict checking if our innerElement contains our 'unnormal' phrase
  for (var j in temp) {
    var innerElement = temp[j];
    var innerElementCopy = new _HighlightItem.default(innerElement.content, innerElement.phraseArr, innerElement.color, innerElement.textColor, innerElement.idx); //we've found an element that contains the 'unnormal' phrase

    if ((0, _ContainsObject.default)(currentElement.phraseArr[i], innerElement.phraseArr)) {
      //if it also contains our target phrase, update its color to the target phrase color otherwise it should be transparent
      if ((0, _ContainsObject.default)(phraseArrEntry, innerElementCopy.phraseArr)) {
        innerElementCopy.updateColor(Targetcolor, 'textWhite');
      } else innerElementCopy.updateColor("none", 'textBlack');
    } else if ((0, _ContainsObject.default)(phraseArrEntry, innerElement.phraseArr)) innerElementCopy.updateColor(Targetcolor, 'textWhite');

    temp[innerElementCopy.idx] = innerElementCopy;
  }
}

var _default = updateHighlights;
exports.default = _default;